SystemOrganization addCategory: #ConfigurationOfOSLinuxUbuntu!

Object subclass: #ConfigurationOfOSLinuxUbuntu
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfOSLinuxUbuntu'!

!ConfigurationOfOSLinuxUbuntu commentStamp: 'TorstenBergmann 1/9/2015 09:44' prior: 0!
Configuration for OS Linux Ubuntu project!

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'development support' stamp: 'TorstenBergmann 1/9/2015 08:52'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'private' stamp: 'TorstenBergmann 1/9/2015 08:52'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'catalog' stamp: 'TorstenBergmann 10/22/2015 15:58'!
catalogChangeLog
	"Returns a paragraph describing the most important changes in the configuration class."
	^ '- 0.1 - 22.10.2015 - initial version
[[[
	ConfigurationOfOSLinuxUbuntu project version: ''0.1'' ) load					
]]]
'! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'catalog' stamp: 'TorstenBergmann 2/8/2016 22:41'!
catalogContactInfo
	"Returns a paragraph describing contact information such as email, mailing lists and website."
	^ 'Contact the author or ask on the pharo-user mailinglist'! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'catalog' stamp: 'TorstenBergmann 10/22/2015 15:59'!
catalogDescription
	"Returns a paragraph describing the project"
	^ 'A part of the OS-XXX series to easier work with native operating system platforms. Here for using Ubuntu Linux environments in Pharo.'! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'catalog' stamp: 'TorstenBergmann 10/22/2015 15:59'!
catalogKeyClassesAndExample
	"Returns a paragraph or more describing the key classes of your project. You can use Pillar/Pier syntax to layout out the text i.e., ==Code== and - for bullet."
	^ ' '! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'catalog' stamp: 'TorstenBergmann 10/22/2015 15:59'!
catalogKeywords
	"Returns an array of symbols"
	^ #(os unix linux ubuntu native) ! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'private' stamp: 'TorstenBergmann 1/9/2015 08:52'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'private' stamp: 'TorstenBergmann 1/9/2015 08:52'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'metacello tool support' stamp: 'TorstenBergmann 1/9/2015 08:52'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'loading' stamp: 'TorstenBergmann 1/9/2015 08:52'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'loading' stamp: 'TorstenBergmann 1/9/2015 08:52'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'loading' stamp: 'TorstenBergmann 1/9/2015 08:52'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'accessing' stamp: 'TorstenBergmann 1/9/2015 08:52'!
project

	^self new project! !

!ConfigurationOfOSLinuxUbuntu class methodsFor: 'development support' stamp: 'TorstenBergmann 1/9/2015 08:52'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfOSLinuxUbuntu methodsFor: 'baselines' stamp: 'TorstenBergmann 1/9/2015 10:41'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/OS/OS-Linux-Ubuntu/main/'.
		spec project: 'OSUnix' with: [
				spec
					className: #ConfigurationOfOSUnix;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/OS/OS-Unix/main/' ].
		spec 
			package: #'OS-Linux-Ubuntu-Core' with: [
				spec requires: #(#OSUnix ). ];
			package: #'OS-Linux-Ubuntu-Environment' with: [
				spec requires: #(#'OS-Linux-Ubuntu-Core' ). ];
			package: 'OS-Linux-Ubuntu-Tools' with: [
				spec requires: #(#'OS-Linux-Ubuntu-Core' #'OS-Linux-Ubuntu-Environment' ). ];
			package: #'OS-Linux-Ubuntu-Tests-Core' with: [
				spec requires: #(#'OS-Linux-Ubuntu-Core' ). ].
		spec 
			group: 'Core' with: #(#'OS-Linux-Ubuntu-Core' #'OS-Linux-Ubuntu-Environment' );
			group: 'Tests' with: #(#'OS-Linux-Ubuntu-Tests-Core' );
			group: 'Tools' with: #('OS-Linux-Ubuntu-Tools' );
			group: 'default' with: #('Core' 'Tests' 'Tools' ). ].
! !

!ConfigurationOfOSLinuxUbuntu methodsFor: 'baselines' stamp: 'TorstenBergmann 1/9/2015 10:44'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/OS/OS-Linux-Ubuntu/main/'.
		spec project: 'OSUnix' with: [
				spec
					className: #ConfigurationOfOSUnix;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/OS/OS-Unix/main/' ].
		spec 
			package: #'OS-Linux-Ubuntu-Core' with: [
				spec requires: #(#OSUnix ). ];
			package: #'OS-Linux-Ubuntu-Environment' with: [
				spec requires: #(#'OS-Linux-Ubuntu-Core' ). ];
			package: 'OS-Linux-Ubuntu-Tools' with: [
				spec requires: #(#'OS-Linux-Ubuntu-Core' #'OS-Linux-Ubuntu-Environment' ). ];
			package: #'OS-Linux-Ubuntu-Tests-Core' with: [
				spec requires: #(#'OS-Linux-Ubuntu-Core' ). ].
		spec 
			group: 'Core' with: #(#'OS-Linux-Ubuntu-Core' #'OS-Linux-Ubuntu-Environment' );
			group: 'Tests' with: #(#'OS-Linux-Ubuntu-Tests-Core' );
			group: 'Tools' with: #('OS-Linux-Ubuntu-Tools' );
			group: 'default' with: #('Core' 'Tests' 'Tools' ). ].
! !

!ConfigurationOfOSLinuxUbuntu methodsFor: 'baselines' stamp: 'TorstenBergmann 2/8/2016 22:35'!
baseline03: spec
	<version: '0.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/OS/OS-Linux-Ubuntu/main/'.
		spec project: 'OSUnix' with: [
				spec
					className: #ConfigurationOfOSUnix;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/OS/OS-Unix/main/' ].
		spec 
			package: #'OS-Linux-Ubuntu-Core' with: [
				spec requires: #(#OSUnix ). ];
			package: #'OS-Linux-Ubuntu-Environment' with: [
				spec requires: #(#'OS-Linux-Ubuntu-Core' ). ];
			package: 'OS-Linux-Ubuntu-Tools' with: [
				spec requires: #(#'OS-Linux-Ubuntu-Core' #'OS-Linux-Ubuntu-Environment' ). ];
			package: #'OS-Linux-Ubuntu-Tests-Core' with: [
				spec requires: #(#'OS-Linux-Ubuntu-Core' ). ].
		spec 
			group: 'Core' with: #(#'OS-Linux-Ubuntu-Core' #'OS-Linux-Ubuntu-Environment' );
			group: 'Tests' with: #(#'OS-Linux-Ubuntu-Tests-Core' );
			group: 'Tools' with: #('OS-Linux-Ubuntu-Tools' );
			group: 'default' with: #('Core' 'Tests' 'Tools' ). ].
! !

!ConfigurationOfOSLinuxUbuntu methodsFor: 'accessing' stamp: 'TorstenBergmann 1/9/2015 08:52'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfOSLinuxUbuntu methodsFor: 'symbolic versions' stamp: 'TorstenBergmann 2/8/2016 22:35'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.3-baseline'.
! !

!ConfigurationOfOSLinuxUbuntu methodsFor: 'accessing' stamp: 'TorstenBergmann 1/9/2015 08:52'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfOSLinuxUbuntu methodsFor: 'symbolic versions' stamp: 'TorstenBergmann 2/8/2016 22:35'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.2'.
! !

!ConfigurationOfOSLinuxUbuntu methodsFor: 'versions' stamp: 'TorstenBergmann 10/22/2015 15:54'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.1'.
		spec author: 'TorstenBergmann'.
		spec timestamp: '1/9/2015 10:43'.
		spec project: 'OSUnix' with: '0.3'.
		spec 
			package: #'OS-Linux-Ubuntu-Core' with: 'OS-Linux-Ubuntu-Core-TorstenBergmann.3';
			package: #'OS-Linux-Ubuntu-Environment' with: 'OS-Linux-Ubuntu-Environment-TorstenBergmann.5';
			package: 'OS-Linux-Ubuntu-Tools' with: 'OS-Linux-Ubuntu-Tools-TorstenBergmann.7';
			package: #'OS-Linux-Ubuntu-Tests-Core' with: 'OS-Linux-Ubuntu-Tests-Core-TorstenBergmann.1'. ].
! !

!ConfigurationOfOSLinuxUbuntu methodsFor: 'versions' stamp: 'TorstenBergmann 2/8/2016 22:35'!
version02: spec
	<version: '0.2' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.1'.
		spec author: 'TorstenBergmann'.
		spec timestamp: '1/9/2015 10:43'.
		spec project: 'OSUnix' with: '0.4'.
		spec 
			package: #'OS-Linux-Ubuntu-Core' with: 'OS-Linux-Ubuntu-Core-TorstenBergmann.6';
			package: #'OS-Linux-Ubuntu-Environment' with: 'OS-Linux-Ubuntu-Environment-TorstenBergmann.7';
			package: 'OS-Linux-Ubuntu-Tools' with: 'OS-Linux-Ubuntu-Tools-TorstenBergmann.7';
			package: #'OS-Linux-Ubuntu-Tests-Core' with: 'OS-Linux-Ubuntu-Tests-Core-TorstenBergmann.3'. ].
! !
